#ifndef RecycleBin_H
#define RecycleBin_H

#include "CircularQueue.h"

template <class T, int maxSize>
class RecycleBin {
private:
	CircularQueueWithoutStats<T *,maxSize> items;

public:
	RecycleBin() {
		items.Setup();
	}

	~RecycleBin() {
		while(items.HasData()) {
			delete items.Pop();
		}
	}

	T *New() {
		if(items.HasData()) {
			return items.Pop();
		}
		return new T();
	}

	void Recycle(T *item) {
		if(items.HasRoom()) {
			items.Push(item);
		} else {
			delete item;
		}
	}
};

#endif
